//=============================================================================================================================
//	
//	TAC2 - Chaser
//	Version 3.0
//	Zengei - June 2006
//
//=============================================================================================================================

package TAC_ChaserGame
{
	//Remove MPB from invs in Chaser
	function StationVehiclePad::createStationVehicle(%data, %player)
	{
		Parent::createStationVehicle(%data, %player);
		%sv = %player.station;
		%sv.vehicle[TACMobileBaseVehicle] = false;
	}
};


//-- tracking  ---
// .deaths .kills .genDefends .carrierKills .flagDefends .escortAssists .suicides .teamKills .turretKills .flagCaps
// .flagReturns .genDestroys .genRepairs

function TAC_ChaserGame::initGameVars(%game)
{
	%game.SCORE_PER_VEHICLE_APC_KILL = 0;  	//enemy team gets this for killing your apc from a vehicle
	%game.SCORE_PER_OTHER_APC_KILL = 0;		//enemy team gets this for killing apc otherwise
	%game.SCORE_PER_OWN_APC_KILL = -10;		//Your team gets this if you tk an apc
	%game.SCORE_PER_BASE_APC_KILL = 0;		//Enemy team gets this if your veihcle is destroyed by enemy base turrets
	%game.SCORE_PER_TURRET_APC_KILL = 0;	//Enemy team gets this for kills by other turrets
	%game.SCORE_PER_CRASH_APC_KILL = -5;	//Your team gets this if you crash an apc
	%game.SCORE_PER_COLLIDE_APC_KILL = 0;	//Your team gets this if you collide with an enemy causing their vehicle to be destroyed

    %game.SCORE_PER_CHASER_KILL = 25; //Your team gets this if you destroy enemy chaser
    %game.SCORE_PER_CHASER_TEAMKILL = -100; //Your team gets this if you destroy your own chaser
	%game.SCORE_PER_CHASER_CRASH = -25; //Your team gets this you crash the wildcat
    %game.SCORE_DEDUCTION_CHASER_TURTLING = -1; //Your team gets this (per second) for keeping the wildcat OOB
    %game.SCORE_ADDITION_CHASER_CRUISING = 1; //your team gets this (per second) for keeping chaser above certain speed
	%game.CHASER_CRUISE_SPEED = 150; //The "certain speed" from above (in km/h)
    %game.SCORE_ADDITION_CHASER_FLYING = 1; //your team gets for keeping chaser above certain altitude ***[UNUSED]***
	%game.CHASER_FLIGHT_CEILING = 10; //The "certain altitude from above (in meters) ***[UNUSED]****
	%game.CHASER_SPAWN_NAME = "ChaserSpawn"; //What object the game looks for when it wants to spawn chaser

	%game.SCORE_PER_SUICIDE = 0;
	%game.SCORE_PER_TEAMKILL = 0;
	%game.SCORE_PER_DEATH = 0;

	%game.SCORE_PER_KILL = 0;
	%game.SCORE_PER_PLYR_FLAG_CAP = 0;
	%game.SCORE_PER_TEAM_FLAG_CAP = 0;
	%game.SCORE_PER_GEN_DESTROY = 0;
	%game.SCORE_PER_ESCORT_ASSIST = 0;

	%game.SCORE_PER_TURRET_KILL = 0;
	%game.SCORE_PER_FLAG_DEFEND = 0;
	%game.SCORE_PER_CARRIER_KILL = 0;
	%game.SCORE_PER_FLAG_RETURN = 0;
	%game.SCORE_PER_GEN_DEFEND = 0;
	%game.SCORE_PER_GEN_REPAIR = 0;

	%game.fadeTimeMS = 2000;
	%game.notifyMineDist = 7.5;
}

//=============================================================================================================================
//
//	Basic game functions
//
//=============================================================================================================================

function TAC_ChaserGame::setUpTeams(%game)
{
	DefaultGame::setUpTeams(%game);
	
	%game.numTeams = 2;
	setSensorGroupCount(%game.numTeams + 1);

	%game.ChaserAdvancedScoring = %game.schedule(1000, "ChaserAdvancedScoring");
	%game.ChaserTerrainCheck = %game.schedule(10000, "ChaserTerrainCheck");
	%game.ChaserWaypointRefresh = %game.schedule(5000,"refreshChaserWaypoint");
	%game.ChaserSpeedRefresh = %game.schedule(30000, "refreshChaserSpeed"); 

	%game.Base1Defence = %game.schedule(10000, "BaseDefence", 1);
	%game.Base2Defence = %game.schedule(10000, "BaseDefence", 2);	
   
	for(%i = 1; %i <= %game.numTeams; %i++){
		$TeamScore[%i] = 0;		
	}
	
	%game.CreateChaserBike();
}


function TAC_ChaserGame::startMatch(%game)
{
	DefaultGame::startMatch(%game);
}

function TAC_ChaserGame::equip(%game, %player)
{
	for(%i =0; %i<$InventoryHudCount; %i++)
		%player.client.setInventoryHudItem($InventoryHudData[%i, itemDataName], 0, 1);

	%player.setInventory(RepairKit,1);
	%player.setInventory(FlareGrenade,6);
	%player.setInventory(Blaster,1);
	%player.setInventory(Chaingun,1);
	%player.setInventory(ChaingunAmmo, 100);
	%player.setInventory(Disc,1);
	%player.setInventory(DiscAmmo, 20);
	%player.setInventory(RepairPack,1);
	%player.setInventory(TargetingLaser, 1);
	%player.weaponCount = 3;
	%player.use("Blaster");
}

function TAC_ChaserGame::missionLoadDone(%game)
{
   	DefaultGame::missionLoadDone(%game);
}

function TAC_ChaserGame::clientMissionDropReady(%game, %client)
{

	%wildcat = $ChaserBikeID;
	
	if(isObject(%wildcat)){
		//Get the name of the client that's piloting the wildcat
		if(isObject($ChaserBikeID.getMountedObject(0))){
			%chasername = $ChaserBikeID.getMountedObject(0).client.name;
		}
		else{
			%chasername = "";
		}
	
		//Find out the health of the wildcat
		%damage = %wildcat.getDamageLevel();
		%totalhealth = %wildcat.getDatablock().destroyedLevel;
		%health = (%totalhealth - %damage)/%totalhealth;
	
   		messageClient(%client, 'MsgClientReady',"", %game.class, %chasername, %health); //Zengei - June 29, 2006 - for extras in objHud
	}
	
   	for(%i = 1; %i <= %game.numTeams; %i++)
   	{
      	messageClient(%client, 'MsgChaserAddTeam', "", %i, $TeamName[%i], $TeamScore[%i]);
   	}

	messageClient(%client, 'MsgMissionDropInfo', '\c0You are in mission %1 (%2).', $MissionDisplayName, $MissionTypeDisplayName, $ServerName );

	DefaultGame::clientMissionDropReady(%game, %client);
}

function TAC_ChaserGame::assignClientTeam(%game, %client, %respawn)
{
   DefaultGame::assignClientTeam(%game, %client, %respawn);
}

function TAC_ChaserGame::updateKillScores(%game, %clVictim, %clKiller, %damageType, %implement)
{
	if(%clKiller <= 0 || %clKiller $= "")
	{
		%game.awardScoreDeath(%clVictim);
	}
	else if (%game.testKill(%clVictim, %clKiller)) //verify victim was an enemy
	{
		%game.awardScoreKill(%clKiller);
		%game.awardScoreDeath(%clVictim);
	}
	else
	{
		if (%game.testSuicide(%clVictim, %clKiller, %damageType))  //otherwise test for suicide
		{
			%game.awardScoreSuicide(%clVictim);
		}
		else
		{
			if (%game.testTeamKill(%clVictim, %clKiller)) //otherwise test for a teamkill
				%game.awardScoreTeamKill(%clVictim, %clKiller);
		}
	}
}

function TAC_ChaserGame::createPlayer(%game, %client, %spawnLoc, %respawn)
{
	DefaultGame::createPlayer(%game, %client, %spawnLoc, %respawn);
}

function TAC_ChaserGame::clientChangeTeam(%game, %client, %team, %fromObs)
{
	DefaultGame::clientChangeTeam(%game, %client, %team, %fromObs);
}

function TAC_ChaserGame::enterMissionArea(%game, %playerData, %player)
{
	if(%player.getState() $= "Dead")
		return;

	%player.client.outOfBounds = false;
	messageClient(%player.client, 'EnterMissionArea', '\c1You are back in the mission area.');
	cancel(%player.alertThread);
}

function TAC_ChaserGame::leaveMissionArea(%game, %playerData, %player)
{
	if(%player.getState() $= "Dead")
		return;

	%player.client.outOfBounds = true;

	if(isObject(%player.getObjectMount())){
		%vehicle = %player.getObjectMount();
		if(%vehicle.chaser){
			messageClient(%player.client, 'LeaveMissionArea', '\c1You have left the mission area. Return or be forcibly ejected from wildcat!~wfx/misc/red_alert.wav');
			%player.alertThread = %game.schedule(1000, "ChaserTurtleAlertPlayer", 15, %player);
			return;
		}
    	else{
        	messageClient(%player.client, 'LeaveMissionArea', '\c1You have left the mission area.');
        	return;
    	}
   	}
   	else{
   		messageClient(%player.client, 'LeaveMissionArea', '\c1You have left the mission area.');
	}
   //Zengei - Revamped on June 27, 2006
}

function TAC_ChaserGame::DisplaySpecialDebriefMessage(%game, %client)
{
	messageClient( %client, 'MsgDebriefResult', "", '<just:center>Team %1 wins because %2s Chaser Bike was destroyed!', $TeamName[%firstTeam], $TeamName[%secondTeam] );
}

function TAC_ChaserGame::DisplaySpecialTeamScore(%game, %client, %score)
{
	%score -= %game.SCORE_PER_CHASER_KILL;
	messageClient( %client, 'MsgDebriefAddLine', "", '<tab:5,155><clip:150>\t%1</clip>\t%2 + Chaser Destroyed', $TeamName[%team], %score );
}

function TAC_ChaserGame::checkScoreLimit(%game, %team)
{
	%scoreLimit = MissionGroup.TAC_Chaser_scoreLimit;
	if(%scorelimit $= "")
		%scoreLimit = 2000;
   	if($TeamScore[%team] >= %scoreLimit)
      	%game.scoreLimitReached();
}

function TAC_ChaserGame::timeLimitReached(%game)
{
	%game.gameOver();
	schedule(5000, %game, cycleMissions);
}

function TAC_ChaserGame::scoreLimitReached(%game)
{
	%game.gameOver();
	schedule( 5000, %game, cycleMissions );
}

function TAC_ChaserGame::gameOver(%game)
{
	messageAll('MsgGameOver', "Match has ended.~wvoice/announcer/ann.gameover.wav" );
	
	DefaultGame::gameOver(%game);
	
	for(%i = 0; %i < ClientGroup.getCount(); %i ++)
	{
		%client = ClientGroup.getObject(%i);
		%game.resetScore(%client);
	}
	
	%game.sendDebriefing();
	messageAll('MsgClearObjHud', "");
 
 	for(%j = 1; %j <= %game.numTeams; %j++)
		$TeamScore[%j] = 0;
		
	cancel(%game.ChaserAdvancedScoring);
	cancel(%game.ChaserTerrainCheck);
	cancel(%game.ChaserWaypointRefresh);
	cancel(%game.Base1Defence);
	cancel(%game.Base2Defence);
	cancel(%game.ChserSpeedRefresh);
}

//=============================================================================================================================
//
//	Extra functions for Chaser
//
//=============================================================================================================================

function TAC_ChaserGame::setChaserWaypoint(%game, %client)
{	
	if(isObject($ChaserBikeID)){
		%wildcat = $ChaserBikeID;
		%target = %wildcat.getTarget();
	
		//setTargetSkin(%wildcat.getTarget(), CTFGame::getTeamSkin(CTFGame, %wildcat.team));
		setTargetSensorGroup(%target, %wildcat.team);
   		setTargetAlwaysVisMask(%target, 0x7);
   		setTargetRenderMask(%target, getTargetRenderMask(%target) | 0x2);
   		setTargetName(%target, "Wildcat Scout");
		%wildcat.scopeWhenSensorVisible(true);
	}   	
}

function TAC_ChaserGame::getValidChaserSpawn(%game)
{
	%spawnName = %game.CHASER_SPAWN_NAME;
	if(nameToId(%spawnName) != -1){
		echo("CHASER: Getting valid spawn location");
		%spawnLoc = nameToID(%spawnName).getTransform();
		
		%mask = $TypeMasks::VehicleObjectType | $TypeMasks::MoveableObjectType | $TypeMasks::StaticShapeObjectType
				| $TypeMasks::ForceFieldObjectType | $TypeMasks::ItemObjectType | $TypeMasks::PlayerObjectType
				| $TypeMasks::TurretObjectType;
		%radius = 0.1;
		%height = 10; //extra height if somethng is found in the way
		
		%spawnBlocked = true;
		while(%spawnBlocked){
			echo("CHASER: Initiating radius search");
    		InitContainerRadiusSearch(%spawnLoc, %radius, %mask);
		
			%obj = ContainerSearchNext();
		
      		if(%obj != 0)
      		{
				//Found something that isn't supposed to be there!
				echo("CHASER: Found something blocking the chaser's spawn");
				%spawnBlocked = true;
			
				%loc = %spawnLoc;
				%posXY = getWords(%loc, 0, 1);
				%posZ = (getWord(%loc, 2) + %height);
				%spawnLoc = %posXY @ " " @ %posZ;
      		}
			if(%obj == 0){
				echo("CHASER: Nothing is blocking the chaser's spawn");
				%spawnBlocked = false;
			}
		}
	}
	echo("CHASER: Returning the valid spawn loation");
	return %spawnLoc;
}

function TAC_ChaserGame::CreateChaserBike(%game)
{
	if(isObject($ChaserBikeID))
	{
		error("ERROR: Chaser Bike already exists.  No new bike created!");
		return;
	}
	
	%spawnLoc = %game.getValidChaserSpawn();
	
	%chaserbike = ScoutVehicle.create();

	%chaserbike.setTransform(%spawnLoc);
	%chaserbike.chaser = true;
		
	$ChaserBikeID = %chaserbike;
	%game.setChaserWaypoint();
	setTargetSensorGroup(%chaserbike.getTarget(), 0);
		
	%damage = $ChaserBikeID.getDamageLevel();
	%totalhealth = $ChaserBikeID.getDatablock().destroyedLevel;
	%health = (%totalhealth - %damage)/%totalhealth;
	
   	messageAll('MsgChaserDamaged',"",%health);
	messageAll('MsgChaserRiderChange',"", "<NO RIDER>");
}



function TAC_ChaserGame::refreshChaserWaypoint(%game)
{
	cancel(%game.ChaserWaypointRefresh);
	%game.setChaserWaypoint();
	%game.ChaserWaypointRefresh = %game.schedule(5000,"refreshChaserWaypoint");
}

function TAC_ChaserGame::refreshChaserSpeed(%game)
{
	cancel(%game.ChserSpeedRefresh);	 
	if(isObject($ChaserBikeID)){
		%chaserbike = $ChaserBikeID;
		%speed = VectorLen(%chaserbike.getVelocity())*3.6;
		%speed = mFloor(%speed);
		messageAll('MsgChaserSpeedUpdate',"", %speed);
	}
	%game.ChaserSpeedRefresh = %game.schedule(500, "refreshChaserSpeed");	
}

function TAC_ChaserGame::RespawnChaserBike(%game)
{
	%game.schedule(2500, CreateChaserBike); //Zengei - Aug. 26, 2003 - There must be a delay for it to respawn
}

function TAC_ChaserGame::ChaserTurtleAlertPlayer(%game, %count, %player)
{
	cancel(%player.alertThread);
	if(!isObject(%player.getObjectMount())){
		//They dismounted the wildcat
		return;
	}
	else if(!%player.getObjectMount().chaser){
		//They're mounted in something, but it's not the wildcat
		return;
	}
	
   	if(%count == 10 || %count == 5){
		if(%player.getState() $= "Dead" || !isObject(%player))
			return;      
	  	messageClient(%player.client, 'LeaveMissionArea', '\c1You have %1 seconds to return or be ejected!~wfx/misc/warning_beep.wav', %count);
	  	%player.alertThread = %game.schedule(1000, "ChaserTurtleAlertPlayer", %count - 1, %player);
	}
	else if(%count > 1){
		if(%player.getState() $= "Dead" || !isObject(%player))
			return;
		%player.alertThread = %game.schedule(1000, "ChaserTurtleAlertPlayer", %count - 1, %player);
	}
   	else{ //Eject the bastard! MUAHAHAHAHAHAAHA
		if(%player.getState() $= "Dead" || !isObject(%player))
			return;
			
		%game.ejectPlayer(%player);
		
		if(%player.client.sex $= "Male")
			%gender = "him";
		else
			%gender = "her";
		messageAll('LeaveMissionArea', '\c1%1 wanted to see the stars and the righteous hammer of Zengei pointed %2 in the right direction!~wfx/misc/hunters_horde.wav', %player.client.name, %gender);
	}
}

function TAC_ChaserGame::ejectPlayer(%game, %player)
{
	cancel(%player.alertThread);
	commandToClient(%player.client,'SetDefaultVehicleKeys', false);

	// Position above dismount point
	%pos    = getWords(%player.getTransform(), 0, 2);
	%oldPos = %pos;
	%vec[0] = " 0  0  2";
	%vec[1] = " 0  0  3";
	%vec[2] = " 0  0 -2";
	%vec[3] = " 2  0  0";
	%vec[4] = "-2  0  0";
	%numAttempts = 5;
	%success     = -1;
	%impulseVec  = "0 0 0";
	if (%player.getObjectMount().getDatablock().hasDismountOverrides() == true)
	{
		%vec[0] = %player.getObjectMount().getDatablock().getDismountOverride(%player.getObjectMount(), %player);
		%vec[0] = MatrixMulVector(%player.getObjectMount().getTransform(), %vec[0]);
	}
	else
	{
		%vec[0] = MatrixMulVector( %player.getTransform(), %vec[0]);
	}
		
	%pos = "0 0 0";
	for (%i = 0; %i < %numAttempts; %i++)
	{
		%pos = VectorAdd(%oldPos, VectorScale(%vec[%i], 3));
	  	if (%player.checkDismountPoint(%oldPos, %pos))
		{
			%success = %i;
			%impulseVec = %vec[%i];
			break;
		}
	}
	if (%forced && %success == -1)
	{
		%pos = %oldPos;
	}
		
	// hide the dashboard HUD and delete elements based on node
	commandToClient(%player.client, 'setHudMode', 'Standard', "", 0);
	// Unmount and control body
	%player.unmount();
	if(%player.mVehicle)
		%player.mVehicle.getDataBlock().playerDismounted(%player.mVehicle, %player);
	
	if(!%player.client.isAIControlled())
   	{
    	%vehicle = %player.getControlObject();
    	%player.setControlObject(0);
   	}
		
	%player.mountVehicle = false;
	%player.schedule(2000, "setMountVehicle", true);
		
	// Position above dismount point
	%player.setTransform(%pos);
	%player.playAudio(0, UnmountVehicleSound);
	%player.applyImpulse(%pos, VectorScale(%impulseVec, %player.getDataBlock().mass * 75));
	%player.setPilot(false);
	%player.setCloaked(false);
	%player.vehicleTurret = "";
}


function TAC_ChaserGame::getChaserBikeID(%game, %team)
{
	return $ChaserBikeID;
}

function TAC_ChaserGame::ChaserAdvancedScoring(%game)
{
    cancel(%game.ChaserAdvancedScoring);
 
    %chaserbike = $ChaserBikeID;
    %team = %chaserbike.team;
    %ChaserTurtle = false;
    %node = 0; //Pilot node

    %enemyteam = %team == 1 ? 2 : 1;
	
    if(isObject(%chaserbike)){
        if(isObject(%chaserbike.getMountedObject(%node))){
			%player = %chaserbike.getMountedObject(%node);
        	if(%player.client.outOfBounds){
            	%ChaserTurtle = true;
        	}
		}
		else{
        	%ChaserTurtle = true;
		}
	

		if($TeamScore[%team] > 0 && %ChaserTurtle)
		{
			%deduction = %game.SCORE_DEDUCTION_CHASER_TURTLING !$= "" ? %game.SCORE_DEDUCTION_CHASER_TURTLING : 0;
			$TeamScore[%team] += %deduction;
	
			%points = %deduction * -1;
			%plural = %points > 1 ? "s" : "";
	
			messageTeam(%team, 'MsgTACChaserPointsLoss', "", $TeamScore[%team], %team);
			messageTeam(%enemyteam, 'MsgTACChaserPointsLoss', "", $TeamScore[%team], %team);
			messageTeam(0, 'MsgTACChaserPointsLoss', "", $TeamScore[%team], %team);
	
			%game.checkScoreLimit(%team);
		}
	
		if(!%ChaserTurtle){
			%velocity = VectorLen(%chaserbike.getVelocity())*3.6; //Converts from m/s to km/h
			if(%velocity >= %game.CHASER_CRUISE_SPEED)
			{
				%addition = %game.SCORE_ADDITION_CHASER_CRUISING;
				$TeamScore[%team] += %addition;
			
				messageTeam(%team, 'MsgTACChaserPointsGain', "", $TeamScore[%team], %team);
				messageTeam(%enemyteam, 'MsgTACChaserPointsGain', "", $TeamScore[%team], %team);
				messageTeam(0, 'MsgTACChaserPointsGain', "", $teamScore[%team], %team);
			
				%game.checkScoreLimit(%team);
			}
		}
	}
	%game.ChaserAdvancedScoring = %game.schedule(1000, "ChaserAdvancedScoring");
}

function TAC_ChaserGame::ChaserTerrainCheck(%game)
{
	cancel(%game.ChaserTerrainCheck);
	
	%chaserbike = $ChaserBikeID;
	if(isObject(%chaserbike)){    	
    	%pos = posFromTransform(%chaserbike.getTransform());
    	%x = getword(%pos, 0);
		%y = getword(%pos, 1);
		%z = getword(%pos, 2);
    	%height = 10000;
    	%start = %pos;
    	%end = %x @ " " @ %y @ " " @ (%z+(%height*2));

    	%playerFound = ContainerRayCast(%start, %end, $TypeMasks::TerrainObjectType, %chaserbike);

    	if(%playerFound != 0){
        	if((getword(%playerFound,3)-%z) > %height){
            	if(isObject(%chaserbike.getMountedObject(0))){
                	%player = %chaserbike.getMountedObject(0);
                	%player.unmount();
                	commandToClient(%player.client, 'setHudMode', 'Standard', "", 0);
	        	}
            	%chaserbike.startFade(1000, 0, true);
            	%chaserbike.schedule(1001, "delete");
	        	%game.RespawnChaserBike(%team);
       		}
    	}
	}

	%game.ChaserTerrainCheck = %game.schedule(3000, "ChaserTerrainCheck");
}

function TAC_ChaserGame::chaserAbandonedCheck(%game, %obj, %player)
{
	if(isObject(%obj)){
		%obj.startFade(1000, 0, true);
    	%obj.schedule(1001, "delete");
	
	
		%plural = %teampoints != 1 ? 's' : "";
		if(%player.team == 1)
			%otherteam = 2;
		else
			%otherteam = 1;
		
		%teampoints = Game.SCORE_PER_CHASER_KILL;
		messageClient(%player.client, 'msgChaserKilled', '\c0Your team lost %1 point%2 because you abandoned the wildcat!~wfx/misc/friend_chaser_vehicle_destroyed.wav', %teampoints, %plural);
		messageTeamExcept(%player.client, 'msgChaserKilled', '\c0Your team lost %1 point%2 because %3 abandoned the wildcat!~wfx/misc/friend_chaser_vehicle_destroyed.wav', %teampoints, %plural, %player.client.name);
		messageTeam(%otherteam, 'msgChaserKilled', '\c0Enemy team lost %1 point%2 because %3 abandoned the wildcat!~wfx/misc/enemy_chaser_vehicle_destroyed.wav', %teampoints, %plural, %player.client.name);
		messageTeam(0, 'msgChaserKilled', '\c0%3 team lost %1 point%2 because %4 abandoned the wildcat!~wfx/misc/chaser_vehicle_destroyed.wav',%teampoints, %plural, $TeamName[%player.team], %player.client.name);
	
	
		if(%teampoints != 0) //No need is going through this if we don't have to
		{
			$TeamScore[%player.team] -= %teampoints;
			MessageAll('msgTACVehicleDestroyed', "", $TeamScore[1], $TeamScore[2]);
		}
	
		Game.RespawnChaserBike(%team);
	}
}

function TAC_ChaserGame::vehicleDestroyed(%game, %vehicle, %destroyer, %damagetype)
{
	DefaultGame::vehicleDestroyed(%game, %vehicle, %destroyer, %damagetype);
	if(%vehicle.chaser)
	{
		%game.chaserDestroyed(%vehicle, %destroyer, %damagetype);
	}
}

function TAC_ChaserGame::chaserDestroyed(%game, %vehicle, %destroyer, %damagetype)
{
	echo("CHASER: The bike was destroyed. Vehicle: "@%vehicle@" Vehicle Team: "@%vehicle.team);
	echo("CHASER: The bike was destroyed. Player: "@%destroyer.client.name@" Player Team: "@%destroyer.team);
	
	if(%vehicle.team != 0)
	{
		echo("CHASER: The bike was owned by team #"@%vehicle.team);
		%attackerteam = %destroyer.team;
		%chaserteam = %vehicle.team;
		%nonchaserteam = %chaserteam == 1 ? 2 : 1;
		%pilot = %vehicle.lastpilot.client;
		
		if(%chaserteam == %attackerteam)
			%teamkill = true;
		else
			%teamkill = false;
		
		if(!isObject(%destroyer))
		{
			%destroyercl = 0;
		}
		else if(%destroyer.client)
		{
			%destroyercl = %destroyer.client;
			%destroyFromVehicle = %destroyercl.vehicleMounted ? true : false;
		}
		else if(%destroyer.getClassName() $= "Turret")
		{
			if(%destroyer.getControllingClient())
			{
				%destroyercl = %destroyer.getControllingClient();
				%destroyFromVehicle = %destroyercl.vehicleMounted ? true : false;
			}
			else
			  %destroyercl = 0;
		}
		else if(%destroyer.getDataBlock().catagory $= "Vehicles")
		{
			if(%damagetype $= $DamageType::Impact || %damagetype $= $DamageType::Ground)
			   %gunnerNode = 0;
			else
			   %gunnerNode = 1;
	
			if(%destroyer.getMountNodeObject(%gunnerNode))
			   %destroyercl = %destroyer.getMountNodeObject(gunnerNode).client;
			else
			   %destroyercl = 0;
	
			%destroyFromVehicle = %destroyercl.vehicleMounted ? true : false;
		}
		else
			%destroyercl = 0;	
		
		//How was the chaser destroyed...
		//CRASH
		if(%damagetype $= $DamageType::Ground || %damagetype $= $DamageType::Lava)
		{
			echo("CHASER: Wildcat was killed by a CRASH");
			//Some formatting...
			%points = %game.SCORE_PER_CHASER_CRASH;
			%displayteampoints = %points*-1;
			%plural = %points != -1 ? 's' : "";
			
			//Inform the pilot
			messageClient(%pilot, 'msgChaserKilled', '\c0Your team lost %4 point%5 because you crashed the wildcat!~wfx/misc/friend_chaser_vehicle_destroyed.wav', %pilot, %displayteampoints * -1, %pilot.name, %displayteampoints, %plural);
			//Inform the pilot's team
			messageTeamExcept(%pilot, 'msgChaserKilled', '\c0Your team lost %4 point%5 because %3 crashed the wildcat!~wfx/misc/friend_chaser_vehicle_destroyed.wav', %pilot, %displayteampoints * -1, %pilot.name, %displayteampoints, %plural);
			//Inform the other team
			messageTeam(%nonchaserteam, 'msgChaserKilled', '\c0Enemy team lost %4 point%5 because %3 crashed the wildcat!~wfx/misc/enemy_chaser_vehicle_destroyed.wav', %pilot, %displayteampoints * -1, %pilot.name, %displayteampoints, %plural);
			//Inform the observers
			messageTeam(0, 'msgChaserKilled', '\c0%6 lost %4 point%5 because %3 crashed the wildcat!~wfx/misc/chaser_vehicle_destroyed.wav', %pilot, %displayteampoints * -1, %pilot.name, %displayteampoints, %plural, $TeamName[%chaserteam]);
			
			//Inform chaser team, even if pilot dies before wildcat
			if(%pilot <= 0)
			{
				messageTeam(%nonchaserteam, 'msgChaserKilled', '\c0Enemy team lost %2 point%3 because their pilotless wildcat crashed!~wfx/misc/enemy_chaser_vehicle_destroyed.wav', %displayteampoints * -1, %displayteampoints, %plural);
				messageTeam(%vehicleteam, 'msgChaserKilled', '\c0Your team lost %2 point%3 because your pilotless wildcat crashed!~wfx/misc/friend_chaser_vehicle_destroyed.wav', %displayteampoints * -1, %displayteampoints, %plural);
			}
			
			//Assign scores
			%pilot.FriendlyVehicleKill++;
			%chaserteam.FriendlyVehicleKill++;
			if(%points != 0) //No need is going through this if we don't have to
			{
				$TeamScore[%chaserteam] += %points;
				if(%destroyercl)
					%game.recalcScore(%destroyercl);
				MessageAll('msgTACVehicleDestroyed', "", $TeamScore[1], $TeamScore[2]);
			}
			
		}
		
		//COLLISION
		else if(%damagetype $= $DamageType::Impact)
		{
			echo("CHASER: Wildcat was killed by a COLLISION");
			%vehiclepilot = %vehicle.lastpilot.client;
	
			%pluraldestroyer = %teampoints != 1 ? 's' : "";
			%pluralvehicle = %teampointsvehicle != -1 ? 's' : "";
			%displayvehicle = %teampointsvehicle * -1;
			
			messageClient(%pilot, 'msgChaserKilled', '\c0Your team\'s wildcat  was destroyed because you collided with %8!~wfx/misc/friend_chaser_vehicle_destroyed.wav', %vehiclepilot, %teampoints * -1, %displayvehicle, %pluralvehicle, %teampoints, %pluraldestroyer, %vehiclepilot.name, %destroyer.client.name);
			messageTeamExcept(%pilot, 'msgChaserKilled', '\c0Your team\'s wildcat was destroyed because %7 collided with %8!~wfx/misc/friend_chaser_vehicle_destroyed.wav', %vehiclepilot, %teampoints * -1, %displayvehicle, %pluralvehicle, %teampoints, %pluraldestroyer, %vehiclepilot.name, %destroyer.client.name);
			messageClient(%destroyer.client, 'msgChaserKilled', '\c0The enemy team\'s wildcat was destroyed because you collided with %7!~wfx/misc/enemy_chaser_vehicle_destroyed.wav', %vehiclepilot, %teampoints * -1, %displayvehicle, %pluralvehicle, %teampoints, %pluraldestroyer, %vehiclepilot.name, %destroyer.client.name);
			messageTeamExcept(%destroyer.client, 'msgChaserKilled', '\c0Your team\'s wildcat was destroyed because %8 collided with %7!~wfx/misc/enemy_chaser_vehicle_destroyed.wav', %vehiclepilot, %teampoints * -1, %displayvehicle, %pluralvehicle, teampoints, %pluraldestroyer, %vehiclepilot.name, %destroyer.client.name);
			messageTeam(0, 'msgChaserKilled', '\c0%9\'s wildcat was destroyed because %8 collided with %7!~wfx/misc/chaser_vehicle_destroyed.wav', %vehiclepilot, %teampoints * -1, %displayvehicle, %pluralvehicle, %teampoints, %pluraldestroyer, %vehiclepilot.name, %destroyer.client.name, $TeamName[%nonvehicleteam], $TeamName[%vehicleteam]);
			
			%nonchaserteam.EnemyVehicleKill++;
			%destroyer.client.EnemyVehicleKill++;
		}
		
		//TEAMKILLED
		else if(%teamkill)
		{
			echo("CHASER: Wildcat was killed by a TEAMKILL");
			%teampoints = game.SCORE_PER_CHASER_TEAMKILL;
			if (%teampoints < 0)
			{
				%plural = %teampoints != -1 ? 's' : "";
				%displayteampoints = %teampoints*-1;
				messageClient(%destroyercl, 'msgChaserKilled', '\c0Your team lost %4 point%5 because you destroyed the friendly wildcat!~wfx/misc/friend_chaser_vehicle_destroyed.wav', %destroyercl, %displayteampoints * -1, %destroyercl.name, %displayteampoints, %plural);
				messageTeamExcept(%destroyercl, 'msgChaserKilled', '\c0Your team lost %4 point%5 because %3 destroyed the friendly wildcat!~wfx/misc/friend_chaser_vehicle_destroyed.wav', %destroyercl, %displayteampoints * -1, %destroyercl.name, %displayteampoints, %plural);
				messageTeam(%nonchaserteam, 'msgChaserKilled', '\c0Enemy team lost %4 point%5 because %3 destroyed their own wildcat!~wfx/misc/enemy_chaser_vehicle_destroyed.wav', %destroyercl, %displayteampoints * -1, %destroyercl.name, %displayteampoints, %plural);
				messageTeam(0, 'msgChaserKilled', '\c0%6 team lost %4 point%5 because %3 destroyed their own wildcat!~wfx/misc/chaser_vehicle_destroyed.wav', %destroyercl, %displayteampoints * -1, %destroyercl.name, %displayteampoints, %plural, $TeamName[%vehicleteam]);
				
				%destroyercl.FriendlyVehicleKill++;
				%chaserteam.FriendlyVehicleKill++;
				echo("LOG: "@%vehicleteam@" vehicle TKed by "@%destroyercl.name@" ("@%destroyercl@")");
				
				if(%teampoints != 0) //No need is going through this if we don't have to
				{
					$TeamScore[%chaserteam] += %teampoints;
					if(%destroyercl)
						%game.recalcScore(%destroyercl);
					MessageAll('msgTACVehicleDestroyed', "", $TeamScore[1], $TeamScore[2]);
				}
			}
		}
		
		//TURRET KILL
		else if(%damagetype $= $DamageType::Turret || %damagetype $= $DamageType::PlasmaTurret || 
		%damagetype $= $DamageType::ElfTurret || %damagetype $= $DamageType::MortarTurret ||
		%damagetype $= $DamageType::MissileTurret || %damagetype $= $DamageType::IndoorDepTurret ||
		%damagetype $= $DamageType::OutdoorDepTurret || %damagetype $= $DamageType::SentryTurret ||
		%damagetype $= $DamageType::MPBMissile)
		{
			echo("CHASER: Wildcat was killed by a TURRET");
			%teampoints = %game.SCORE_PER_CHASER_KILL;
			%plural = %teampoints != 1 ? 's' : "";
			if(%destroyercl == 0)
			{
				messageTeam(%nonchaserteam, 'msgChaserKilled', '\c0Enemy wildcat was destroyed by a turret!~wfx/misc/enemy_chaser_vehicle_destroyed.wav', 0, %teampoints, "", %teampoints, %plural);
				messageTeam(%chaserteam, 'msgChaserKilled', '\c0Friendly wildcat was destroyed by a turret!~wfx/misc/friend_chaser_vehicle_destroyed.wav', 0, %teampoints, "", %teampoints, %plural);
				messageTeam(0, 'msgChaserKilled', '\c0%6 team\'s wildcat was detroyed by a turret!~wfx/misc/chaser_vehicle_destroyed.wav', 0, %teampoints, "", %teampoints, %plural, $TeamName[%nonvehicleteam]);
				%nonvehicleteam.EnemyVehicleKill++;
			}
			else
			{
				messageClient(%destroyercl, 'msgChaserKilled', '\c0Your team recieved %4 point%5 because you detroyed the enemy wildcat with a turret!~wfx/misc/friend_chaser_vehicle_destroyed.wav', %destroyercl, %teampoints, %destroyercl.name, %teampoints, %plural);
				messageTeamExcept(%destroyercl, 'msgChaserKilled', '\c0Your team recieved %4 point%5 because the enemy wildcat was destroyed by a turret controlled by %3!~wfx/misc/friend_chaser_vehicle_destroyed.wav', %destroyercl, %teampoints, %destroyercl.name, %teampoints, %plural);
				messageTeam(%chaserteam, 'msgChaserKilled', '\c0Enemy team recieved %4 point%5 because your wildcat was destroyed by a turret controlled by %3!~wfx/misc/enemy_chaser_vehicle_destroyed.wav', %destroyercl, %teampoints, %destroyercl.name, %teampoints, %plural);
				messageTeam(0, 'msgChaserKilled', '\c0%6 team recieved %4 point%5 because the wildcat was detroyed by a turret controlled by %3!~wfx/misc/chaser_vehicle_destroyed.wav', %destroyercl, %teampoints, %destroyercl.name, %teampoints, %plural, $TeamName[%attackteam]);
				%nonchaserteam.EnemyVehicleKill++;
			}
			echo("LOG: "@%vehicleteam@" vehicle destroyed by turret");
			
			if(%destroyercl != 0) //It was a person that was doing the shooting
			{
				if(%teampoints != 0) //No need is going through this if we don't have to
				{
					$TeamScore[%nonchaserteam] += %teampoints;
					if(%destroyercl)
						%game.recalcScore(%destroyercl);
					MessageAll('msgTACVehicleDestroyed', "", $TeamScore[1], $TeamScore[2]);
					%game.checkScoreLimit(%nonchaserteam);
				}
			}
		}
		
		//FREAK OCCURANCE
		else if(%destroyercl == 0)
		{
			echo("CHASER: Wildcat was killed by a FREAK OCCURANCE");
			%teampoints = 0;
			messageTeam(%chaserteam, 'msgChaserKilled', '\c0Your team\'s wildcat was destroyed by witnessing the sheer awesomeness of Zengei!~wfx/misc/friend_chaser_vehicle_destroyed.wav',0, 0);
			messageTeam(%nonchaserteam, 'msgChaserKilled', '\c0Enemy team\'s wildcat was destroyed by the righteous hammer of Zengei!~wfx/misc/enemy_chaser_vehicle_destroyed.wav',0, 0);
			messageTeam(0, 'msgChaserKilled', '\c0%1\'s wildcat was destroyed by a freak occurance!~wfx/misc/chaser_vehicle_destroyed.wav', $TeamName[%chaserteam]);
			echo("LOG: "@%vehicleteam@" vehicle detsroyed by freak occurance");
		}
		
		//REGULAR KILL
		else
		{
			echo("CHASER: Wildcat was killed by a REGULAR KILL");
			%teampoints = %game.SCORE_PER_CHASER_KILL;
	
			if(%teampoints <= 0)
			{
				messageTeam(%nonchaserteam, 'msgChaserKilled', '\c0The enemy wildcat was destroyed by %3!~wfx/misc/enemy_chaser_vehicle_destroyed.wav', %destroyercl, %teampoints, %destroyercl.name, %teampoints, %plural);
				messageTeam(%chaserteam, 'msgChaserKilled', '\c0Your wildcat was destroyed by %3!~wfx/misc/friend_chaser_vehicle_destroyed.wav', %destroyercl, %teampoints, %destroyercl.name, %teampoints, %plural);
				messageTeam(0, 'msgChaserKilled', '\c0%6\'s wildcat was destroyed by %3!~wfx/misc/chaser_vehicle_destroyed.wav', %destroyercl, %teampoints, %destroyercl.name, %teampoints, %plural, $TeamName[%chaserteam]);
			}
			else
			{
				%plural = %teampoints != 1 ? 's' : "";
				messageClient(%destroyercl, 'msgChaserKilled', '\c0Your team recieved %4 point%5 because you destroyed the enemy wildcat!~wfx/misc/enemy_chaser_vehicle_destroyed.wav', %destroyercl, %teampoints, %destroyercl.name, %teampoints, %plural);
				messageTeamExcept(%destroyercl, 'msgChaserKilled', '\c0Your team recieved %4 point%5 because %3 destroyed the enemy wildcat!~wfx/misc/enemy_chaser_vehicle_destroyed.wav', %destroyercl, %teampoints, %destroyercl.name, %teampoints, %plural);
				messageTeam(%vehicleteam, 'msgChaserKilled', '\c0Enemy team recieved %4 point%5 because %3 destroyed your team\'s wildcat!~wfx/misc/friend_chaser_vehicle_destroyed.wav', %destroyercl, %teampoints, %destroyercl.name, %teampoints, %plural);
				messageTeam(0, 'msgChaserKilled', '\c0%6 team recieved %4 point%5 because %3 destroyed the enemy team\'s wildcat!~wfx/misc/chaser_vehicle_destroyed.wav', %destroyercl, %teampoints, %destroyercl.name, %teampoints, %plural, $TeamName[%nonvehicleteam]);
				%destroyercl.EnemyVehicleKill++;
				%nonvehicleteam.EnemyVehicleKill++;
				%attackteam = %nonvehicleteam;
			}
			echo("LOG: "@%vehicleteam@" vehicle destroyed by "@%destroyercl.name@" ("@%destroyercl@")");
			
			if(%teampoints != 0) //No need is going through this if we don't have to
			{
				$TeamScore[%nonchaserteam] += %teampoints;
				if(%destroyercl)
					%game.recalcScore(%destroyercl);
				MessageAll('msgTACVehicleDestroyed', "", $TeamScore[1], $TeamScore[2]);
				%game.checkScoreLimit(%nonchaserteam);
			}
			
		}
	}
	//Respawn the chaser!
	%game.RespawnChaserBike();
}

//=============================================================================================================================
//
//	Modifications to the wildcat code for Chaser
//
//=============================================================================================================================

function ScoutVehicle::playerDismounted(%data, %obj, %player)
{
	messageAll('MsgChaserRiderChange',"", "<NO RIDER>");
	%obj.abandonedcheck = Game.schedule(3000, "chaserAbandonedCheck", %obj, %player);
}

function ScoutVehicle::playerMounted(%data, %obj, %player, %node)
{
   	// scout vehicle == SUV (single-user vehicle)
   	commandToClient(%player.client, 'setHudMode', 'Pilot', "Hoverbike", %node);
	
	setTargetSensorGroup(%obj.getTarget(), %player.client.getSensorGroup());
   	%obj.team = %player.team;  
	
   	// update observers who are following this guy...
   	if( %player.client.observeCount > 0 )
		resetObserveFollow( %player.client, false );
		
	messageAll('MsgChaserRiderChange',"",%player.client.name);
	
	//Play announcement
	%playerteam = %player.team;
	if(%playerteam == 1)
		%otherteam = 2;
	else
		%otherteam = 1;
	
	messageTeam(%playerteam, 'msgChaserTaken', '\c1%1 has taken the wildcat for your team!~wfx/misc/flipflop_taken.wav',%player.client.name);
	messageTeam(%otherteam, 'msgChaserTaken', '\c1%1 has taken the wildcat for the enemy team!~wfx/misc/flipflop_lost.wav',%player.client.name);
	messageTeam(0, 'msgChaserTaken', '\c1%1 has taken the wildcat for %2!~wfx/misc/flipflop_taken.wav',%player.client.name, $TeamName[%playerteam]);
}

function ScoutVehicle::onDamage(%this, %obj)
{
	%damage = $ChaserBikeID.getDamageLevel();
	%totalhealth = $ChaserBikeID.getDatablock().destroyedLevel;
	%health = (%totalhealth - %damage)/%totalhealth;
	
   	messageAll('MsgChaserDamaged',"",%health);
   	Parent::onDamage(%this, %obj);
}

