//Major overhaul and update 19-03-03 SaNTa
//=====================================================================================
//	TAC2 - Retrieval Mission Code								Wizard_TPG - 11/5/2001
//                                                              Ransacked by SaNTa ;)
//	This code includes:
//				Retrieval Game Code
//				Player spawns with repair pack
//
//=====================================================================================


//exec the AI scripts
// exec("scripts/aiCTF.cs");

//-- tracking  ---         //moved up to here SaNTa 19-03-03
// .deaths .kills .genDefends .carrierKills .flagDefends .escortAssists .suicides .teamKills .turretKills .flagCaps
// .flagReturns .genDestroys .genRepairs

function TAC_RetrievalGame::initGameVars(%game)
{
	%game.SCORE_PER_VEHICLE_APC_KILL = 3;  	//enemy team gets this for killing your apc from a vehicle
	%game.SCORE_PER_OTHER_APC_KILL = 0;		//enemy team gets this for killing apc otherwise
	%game.SCORE_PER_OWN_APC_KILL = -3;		//Your team gets this if you tk an apc
	%game.SCORE_PER_BASE_APC_KILL = 0;		//Enemy team gets this if your veihcle is destroyed by enemy base turrets
	%game.SCORE_PER_TURRET_APC_KILL = 1;	//Enemy team gets this for kills by other turrets
	%game.SCORE_PER_CRASH_APC_KILL = -1;	//Your team gets this if you crash an apc
	%game.SCORE_PER_COLLIDE_APC_KILL = 1;	//Your team gets this if you collide with an enemy causing their vehicle to be destroyed
	%game.SCORE_PER_ARTIFACT_CAPTURE = 20000;

	%game.SCORE_PER_SUICIDE = 0;
	%game.SCORE_PER_TEAMKILL = 0;
	%game.SCORE_PER_DEATH = 0;

	%game.SCORE_PER_KILL = 0;
	%game.SCORE_PER_PLYR_FLAG_CAP = 0;
	%game.SCORE_PER_TEAM_FLAG_CAP = 10;
	%game.SCORE_PER_GEN_DESTROY = 0;
	%game.SCORE_PER_ESCORT_ASSIST = 0;

	%game.SCORE_PER_TURRET_KILL = 0;
	%game.SCORE_PER_FLAG_DEFEND = 0;
	%game.SCORE_PER_CARRIER_KILL = 0;
	%game.SCORE_PER_FLAG_RETURN = 0;
	%game.SCORE_PER_GEN_DEFEND = 0;
	%game.SCORE_PER_GEN_REPAIR = 0;

	%game.FLAG_RETURN_DELAY = 15 * 1000;

	%game.TIME_CONSIDERED_FLAGCARRIER_THREAT = 0;  //after damaging enemy flag carrier
	%game.RADIUS_GEN_DEFENSE = 0;  //meters
	%game.RADIUS_FLAG_DEFENSE = 0;  //meters

	%game.fadeTimeMS = 2000;
	%game.notifyMineDist = 7.5;
}

//--------------------------------------------------------------------------------------------------------------------

package TAC_RetrievalGame
{
	function TACArtifact::objectiveInit(%data, %artifact)
	{
	   $ArtifactStatus = "<In the Field>";
	}

	function WheeledVehicle::liquidDamage(%obj, %data, %damageAmount, %damageType)
	{
		%artifact = Game.artifact;

		if(!%obj.canDeploy)
			Game.RespawnArtifact("liquid");
	   	parent::liquidDamage(%obj, %data, %damageAmount, %damageType);
	}
 
    // Function added and modified SaNTa 19-03-03
   function ShapeBaseData::onDestroyed(%data, %obj)
{
         // SaNTa 19-03-03
}

//added 19-03-03 SaNTa
   function ShapeBaseData::onDisabled(%data, %obj)
     {
     %obj.wasDisabled = true;
     Parent::onDisabled(%data, %obj);
     }
     //added 19-03-03 SaNTa
     function RepairGunImage::onRepair(%this, %obj, %slot)
     {
     Parent::onRepair(%this, %obj, %slot);
     %target = %obj.repairing;
     if(%target && %target.team != %obj.team)
         {
        //error("Enemy stuff("@%obj@") is being repaired (by "@%target@")");
        %target.soiledByEnemyRepair = true;
         }
     }

};






// Game Structure


function TAC_RetrievalGame::missionLoadDone(%game)
{
	%game.numTeams = 2;

   //continue with the default function
   DefaultGame::missionLoadDone(%game);
}

function TAC_RetrievalGame::setUpTeams(%game)
{
	DefaultGame::setUpTeams(%game);

	//Set up sensor group colours
	%bluemask |= (1 << 6);
	setSensorGroupColor(1, %bluemask, "0 0 255 255"); //blue
	setSensorGroupColor(2, %bluemask, "0 0 255 255"); //blue

	//spawn Artifact
	%game.CreateArtifact();

	//Start distance check loop
	%game.schedule(1000,"ArtifactDistanceCheck");
    //Start the base defence check SaNTa 09-03-03
    %game.Base1Defence = %game.schedule(10000, "BaseDefence", 1);  // New Base Defence SaNTa
    %game.Base2Defence = %game.schedule(10000, "BaseDefence", 2);
//    $TeamScore[1] = 0;    // This makes sure the team score is zero next mission because of delayed vehicle crashes SaNta 23-03-03
//    $TeamScore[2] = 0;    // This makes sure the team score is zero next mission because of delayed vehicle crashes SaNta 23-03-03

   	//Set to two teams
   	%game.numTeams = 2;
   	setSensorGroupCount(%game.numTeams + 1);
    
       for(%i = 0; %i <= %game.numTeams; %i++)
		$TeamScore[%i] = 0;

       error("LOG: Team Scores Cleared for Retrieval Game");
}


function TAC_RetrievalGame::equip(%game, %player)
{
   for(%i =0; %i<$InventoryHudCount; %i++)
      %player.client.setInventoryHudItem($InventoryHudData[%i, itemDataName], 0, 1);

   %player.setInventory(RepairKit,1);
   %player.setInventory(FlareGrenade,6);
   %player.setInventory(Blaster,1);
   %player.setInventory(Chaingun,1);
   %player.setInventory(ChaingunAmmo, 100);
   %player.setInventory(Disc,1);
   %player.setInventory(DiscAmmo, 20);
   %player.setInventory(RepairPack,1);
   %player.setInventory(TargetingLaser, 1);
   %player.weaponCount = 3;
   %player.use("RepairPack");
}

function TAC_RetrievalGame::timeLimitReached(%game)
{
	echo("LOG: game over (timelimit)");
	%game.gameOver();
   schedule( 5000, %game, cycleMissions );
}


function TAC_RetrievalGame::scoreLimitReached(%game)
{
	echo("LOG: game over (scorelimit)");
	%game.gameOver();
   schedule( 5000, %game, cycleMissions );
}

function TAC_RetrievalGame::gameOver(%game)
{
	//send the winner message
	%winner = "";
	if ($teamScore[1] > $teamScore[2])
		%winner = $teamName[1];
	else if ($teamScore[2] > $teamScore[1])
		%winner = $teamName[2];

	if (%winner $= 'Storm')
	   messageAll('MsgGameOver', "Match has ended.~wvoice/announcer/ann.stowins.wav" );
	else if (%winner $= 'Inferno')
	   messageAll('MsgGameOver', "Match has ended.~wvoice/announcer/ann.infwins.wav" );
	else
	   messageAll('MsgGameOver', "Match has ended.~wvoice/announcer/ann.gameover.wav" );

	//call the default
	DefaultGame::gameOver(%game);

   %game.sendDebriefing();
	messageAll('MsgClearObjHud', "");
	for(%i = 0; %i < ClientGroup.getCount(); %i ++)
	{
		%client = ClientGroup.getObject(%i);
		%game.resetScore(%client);
	}
   for(%j = 1; %j <= %game.numTeams; %j++)
		$TeamScore[%j] = 0;
}

function TAC_RetrievalGame::clientMissionDropReady(%game, %client)
{
   	messageClient(%client, 'MsgClientReady',"", %game.class);
   	for(%i = 1; %i <= %game.numTeams; %i++)
   	{
      	messageClient(%client, 'MsgRetrievalAddTeam', "", %i, $TeamName[%i], $TeamScore[%i], $ArtifactStatus);
   	}
	messageClient(%client, 'MsgMissionDropInfo', '\c0You are in mission %1 (%2).', $MissionDisplayName, $MissionTypeDisplayName, $ServerName );

	DefaultGame::clientMissionDropReady(%game, %client);
}


function TAC_RetrievalGame::assignClientTeam(%game, %client, %respawn)
{
   	DefaultGame::assignClientTeam(%game, %client, %respawn);
	// if player's team is not on top of objective hud, switch lines
	messageClient(%client, 'MsgCheckTeamLines', "", %client.team);
}

function TAC_RetrievalGame::updateKillScores(%game, %clVictim, %clKiller, %damageType, %implement)
{
	if(%clKiller <= 0 || %clKiller $= "")
	{
		%game.awardScoreDeath(%clVictim);
	}
	else if (%game.testKill(%clVictim, %clKiller)) //verify victim was an enemy
	{
		%game.awardScoreKill(%clKiller);
		%game.awardScoreDeath(%clVictim);
	}
	else
	{
		if (%game.testSuicide(%clVictim, %clKiller, %damageType))  //otherwise test for suicide
		{
			%game.awardScoreSuicide(%clVictim);
		}
		else
		{
			if (%game.testTeamKill(%clVictim, %clKiller)) //otherwise test for a teamkill
				%game.awardScoreTeamKill(%clVictim, %clKiller);
		}
	}
}

function TAC_RetrievalGame::checkScoreLimit(%game, %team)
{
	echo("*** current score = ",$TeamScore[1]," - ",$TeamScore[2]);
	%scoreLimit = 10000;
   	if($TeamScore[%team] >= %scoreLimit)
      	%game.scoreLimitReached();
}

function TAC_RetrievalGame::enterMissionArea(%game, %playerData, %player)
{
	if(%player.getState() $= "Dead")
	return;

   	%player.client.outOfBounds = false;
   	messageClient(%player.client, 'EnterMissionArea', '\c1You are back in the mission area.');
	//the instant a player leaves the mission boundary, the flag is dropped, and the return is scheduled...
//	if (%player.holdingFlag > 0)            No flag, SaNTa
//	{
//		cancel($FlagReturnTimer[%player.holdingFlag]);
//		$FlagReturnTimer[%player.holdingFlag] = "";
//	}
}

//All this moved to default games cs, SaNTa 05-03-03
//function TAC_RetrievalGame::vehicleDestroyed(%game, %data, %obj)
//{
//	Parent::vehicleDestroyed(%game, %data, %obj);
//
//
//   	if ( %data.getDataBlock().className $= WheeledVehicleData && %data.canDeploy == false)
//   	{
//		$ArtifactStatus = "<In the Field>";
//		messageAll('msgRetievalArtifactLost', '\c0The MPB carrying the Artifact was destroyed!~wfx/misc/MPB_Artifact_Destroyed.wav', $ArtifactStatus);
//		%game.ArtifactTimer();
//		%artifact = %game.artifact;
//		//%artifact.carrier = 0;     SaNTa 01-11-02
//        //%data.unmountObject(1);   Changed to the below
//		%data.unmountObject(%artifact);
//        %artifact.carrier = 0;
//
//
//		if(%data.LastDamageType == $DamageType::Water)
//		{
//			%outputSpawn = %game.GetArtifactSpawnPoint();
//			%artifact.setTransform(%outputSpawn);
//			cancel(%game.ground);
//			%game.ground = %game.schedule(1000, "RespawnArtifact", "liquid");
//			return;
//		}
//
//
//		//move artifact onto ground
//		cancel(%game.ground);
//		%game.ground = %game.schedule(500, "GroundArtifact");
//	}
//}

function TAC_RetrievalGame::ArtifactDistanceCheck(%game)
{

    %testarti = %game.artifact;       // This finaly solves the  ghosting artifact problem by forcing it to update all the time SaNTa     06-03-03
    if(%testarti.isMounted())
        {
        %artiridingon = %testarti.getObjectMount();
        %obj =  %artiridingon;
        %artifact = Game.artifact;
        %obj.unmountObject(%artifact);
	    %obj.mountObject(%artifact, 1);
	    %obj.canDeploy = false;
        }



	%artifact = %game.artifact;
	%artifactPosition = %artifact.getTransform();
	%Team1ReturnDist = vectorDist( %artifactPosition, nameToId(Team1Return).position );
	%Team2ReturnDist = vectorDist( %artifactPosition, nameToId(Team2Return).position );

	if(%Team1ReturnDist <= 10 && %Team1ReturnDist > 0)
	{
		%team = 1;
		%teampoints = %game.SCORE_PER_ARTIFACT_CAPTURE;
		$TeamScore[%team] += %teampoints;
		%game.checkScoreLimit(%team);
	}
	else if(%Team2ReturnDist <= 10 && %Team2ReturnDist > 0)
	{
		%team = 2;
		%teampoints = %game.SCORE_PER_ARTIFACT_CAPTURE;
		$TeamScore[%team] += %teampoints;
		%game.checkScoreLimit(%team);
	}
	else
		%game.schedule(1000,"ArtifactDistanceCheck");
}

function TAC_RetrievalGame::DisplaySpecialDebriefMessage(%game, %client, %firstTeam, %secondTeam)
{
	messageClient( %client, 'MsgDebriefResult', "", '<just:center>Team %1 wins because they managed to recover the Artifact!', $TeamName[%firstTeam]);
}

function TAC_RetrievalGame::DisplaySpecialTeamScore(%game, %client, %score, %team)
{
	%score -= %game.SCORE_PER_ARTIFACT_CAPTURE;
	messageClient( %client, 'MsgDebriefAddLine', "", '<tab:5,155><clip:150>\t%1</clip>\t%2 + Artifact Recovered', $TeamName[%team], %score );
}

function TAC_RetrievalGame::leaveMissionArea(%game, %playerData, %player)
{
   	defaultgame::leaveMissionArea(%game, %playerData, %player);

	//check if player is leaving mission area with artifact -- respawn it if they are
	if(!%player.mpbpilot)
		return;
	%vehicle = %player.mpbpilot;
	if(isObject(%vehicle))
	{
		if(%vehicle.canDeploy)
			return;
		%artifact = %game.artifact;
		%vehicle.unmountObject(%artifact);
		%game.RespawnArtifact("oob");
//		%vehicle.setThreadDir($DeployThread, false);
//		%vehicle.playThread($DeployThread,"deploy");
//		%vehicle.playAudio(0, MobileBaseTurretDeploySound);
		%vehicle.canDeploy = true;
	}
}


//-------------------------------------------------------------------------------
//	Artifact Code

function TAC_RetrievalGame::CreateArtifact(%game)
{
	%outputSpawn = %game.GetArtifactSpawnPoint();
	if(%outputSpawn == -1)
		Error("TAC_Retrieval: Artifact did not spawn!");
	%artifact = TACArtifact.create(%team,%outputSpawn);
	$ArtifactStatus	= "<In the Field>";
	%artifact.artifact = true;
	%game.artifact = %artifact;
	setTargetName(%artifact.getTarget(), "Artifact");
	//%game.ArtifactTimer();
}

function TAC_RetrievalGame::GetArtifactSpawnPoint(%game)
{
	%team = 6;
	if(nameToId(ArtifactSpawn1) != -1)
	{
		%imax = 2;
		for(%i=1;%i<%imax; %i++)
		{
			%nextname = "ArtifactSpawn" @ %i;
			if(nameToId(%nextname) != -1)
			{
				%imax++;
				%spawnPosition[%i] = nameToId(%nextname).position;
			}
		}

		//Pick random point
		%maxspawnpoints = %imax - 1;
		%testvalue = mFloor(getRandom() * %maxspawnpoints);
		if(%testvalue > %maxspawnpoints)
			%testvalue = %maxspawnpoints;
		if(%spawnPosition[%testvalue] $= "")
			%testvalue = 1;
		%spawnLoc = %spawnPosition[%testvalue];
	}
	else
		%spawnLoc = -1;
	if(%spawnLoc == -1)
	{
		echo("TAC_Retrieval: Default Artifact spawn method failure.  Looking for team 6 spawns");
		%spawnLoc = %game.pickTeamSpawn(%team);
	}

  //Removed as we dont want it to drop on the ground as such, causes problems in Hubbards tunnel SaNTa 06-03-03
//	//Determine ground point
//	for(%loc = 0;%loc<7;%loc++)
//	{
//		%locdata[%loc] = getword(%spawnLoc,%loc);
//	}
//	%start = %locdata[0] @ " " @ %locdata[1] @ " 2000";
//	%end = %locdata[0] @ " " @ %locdata[1] @ " -1";
//	%ground = containerRayCast(%start, %end, $TypeMasks::TerrainObjectType, 0);
//	%z = getWord(%ground, 3) + 1;
//	for(%loc = 0;%loc<7;%loc++)
//	{
//		if(%loc == 2)
//			%outputSpawn = %outputSpawn SPC %z;
//		else if(%loc == 0)
//			%outputSpawn = %locdata[0];
//		else
//			%outputSpawn = %outputSpawn SPC %locdata[%loc];
//	}
//	return %outputSpawn;
}

function TAC_RetrievalGame::RespawnArtifact(%game, %reason)
{
	%obj = %game.artifact;
	%outputSpawn = %game.GetArtifactSpawnPoint();
	if(%outputSpawn == -1)
		Error("TAC_Retrieval: Artifact could not re-spawn!");
	cancel(%game.ground);
	cancel(%game.ArtifactTimerSchedule);

	%obj.setTransform(%outputSpawn);
	//%game.ArtifactTimerSchedule = %game.schedule(360000, "RespawnArtifact", "timeout");      Couldnt see why this was needed, SaNTa 31-10-02
	//%game.ArtifactTimerSchedule = %game.schedule(60000, "RespawnArtifact", %obj, "timeout");
	$ArtifactStatus	= "<In the Field>";
	if(%reason $= "liquid")
		messageAll('MsgArtifactRespawn', 'The artifact has randomly respawned due to being lost in liquid~wfx/misc/Artifact_Respawn.wav', $ArtifactStatus );
	else if(%reason $= "timeout")
		messageAll('MsgArtifactRespawn', 'The artifact has not been picked up in 10 minutes and has randomly respawned.~wfx/misc/Artifact_Respawn.wav', $ArtifactStatus );
	else if(%reason $= "oob")
		messageAll('MsgArtifactRespawn', 'The artifact has randomly respawned as it was taken out of the mission area.~wfx/misc/Artifact_Respawn.wav', $ArtifactStatus );
}

function TAC_RetrievalGame::PickUpArtifact(%game, %vehicle, %artifact)
{
	$ArtifactStatus = "<Carried On MPB>";
	cancel(%game.ArtifactTimerSchedule);
	cancel(%game.ground);
//	%vehicle.playThread($DeployThread,"deploy");   Dont want it to "deploy" SaNTa 06-03-03
	%vehicle.mountObject(%artifact, 1);  // SaNTa 11-02-03
//  %vehicle.mountObject(%artifact, 2);  // SaNTa 11-02-03
	%vehicle.canDeploy = false;

	%artifact = %game.artifact;
	%artifact.carrier = %vehicle;

	%pilot = %vehicle.lastpilot.client;
	%enemyteam = %pilot.team == 1 ? 2 : 1;
	messageClient(%pilot, 'msgRetievalArtifactTaken', '\c0You have loaded the artifact onto your MPB! Now get it to the your teams Retrieval Station!~wfx/misc/Pilot_Artifact_Loaded.wav', $ArtifactStatus);
	messageTeamExcept(%pilot, 'msgRetievalArtifactTaken', '\c0Your team has loaded the Artifact onto your MPB!~wfx/misc/Friend_Artifact_Loaded.wav', $ArtifactStatus);
	messageTeam(%enemyteam, 'msgRetievalArtifactTaken', '\c0Enemy team has loaded the Artifact onto their MPB! Stop Them!~wfx/misc/Enemy_Artifact_Loaded.wav', $ArtifactStatus);
	messageTeam(0, 'msgRetievalArtifactTaken', '\c0%2 team has loaded the Artifact onto their MPB!~wfx/misc/Artifact_Loaded.wav', $ArtifactStatus, $TeamName[%pilot.team]);
}

function TAC_RetrievalGame::ArtifactTimer(%game)
{
	%artifact = %game.artifact;
	cancel(%game.ArtifactTimerSchedule);
	%game.ArtifactTimerSchedule = %game.schedule(300000, "RespawnArtifact", "timeout");    //Up to 10 mins, SaNTa 31-10-02
	//%game.ArtifactTimerSchedule = %game.schedule(60000, "RespawnArtifact", %artifact, "timeout");
}


function TAC_RetrievalGame::GroundArtifact(%game)
{

	%artifact = %game.artifact;
    if(isobject(%artifact.carrier))
		return;
  
 %outputSpawn = getword(%spawnLoc,%loc);
 %artifact.setTransform( %outputSpawn );
}

//function TAC_RetrievalGame::GroundArtifact(%game)
//{
//	%artifact = %game.artifact;
//    if(isobject(%artifact.carrier))
//		return;

//	%spawnLoc = %artifact.getPosition();
//	for(%loc = 0;%loc<7;%loc++)
//	{
//		%locdata[%loc] = getword(%spawnLoc,%loc);
//	}
//	%start = %locdata[0] @ " " @ %locdata[1] @ " 2000";
//	%end = %locdata[0] @ " " @ %locdata[1] @ " -1";
//	%ground = containerRayCast(%start, %end, $TypeMasks::InteriorObjectType | $TypeMasks::TerrainObjectType, 0);     //Added the interior object SaNTa
//	%z = getWord(%ground, 3) + 0.1;
//	for(%loc = 0;%loc<7;%loc++)
//	{
//		if(%loc == 2)
//			%outputSpawn = %outputSpawn SPC %z;
//		else if(%loc == 0)
//			%outputSpawn = %locdata[0];
//		else
//			%outputSpawn = %outputSpawn SPC %locdata[%loc];
//	}
//	%artifact.setTransform( %outputSpawn );
//
//}


function TAC_RetrievalGame::dropFlag(%game, %player)
{
 // More console errors gone bye bye. SaNTa 06-11-02
}


function TAC_RetrievalGame::onClientDamaged(%game, %clVictim, %clAttacker, %damageType, %implement, %damageLoc)
{
   //SaNTa 19-03-03
}
//Added SaNTa 19-03-03
function TAC_RetrievalGame::resetScore(%game, %client)
{
   DefaultGame::resetScore(%game, %client); //ZENGEI - Just fixing some bugs :P - June 24, 2006
//   %client.offenseScore = 0;
   %client.kills = 0;
   %client.deaths = 0;
   %client.suicides = 0;
//   %client.escortAssists = 0;
   %client.teamKills = 0;
//   %client.flagCaps = 0;
//   %client.flagGrabs = 0;
//   %client.genDestroys = 0;
//   %client.sensorDestroys = 0;
//   %client.turretDestroys = 0;
//   %client.iStationDestroys = 0;
//   %client.vstationDestroys = 0;
//   %client.solarDestroys = 0;
//   %client.sentryDestroys = 0;
//   %client.depSensorDestroys = 0;
//   %client.depTurretDestroys = 0;
//   %client.depStationDestroys = 0;
   %client.vehicleScore = 0;
   %client.vehicleBonus = 0;

//    %client.flagDefends = 0;
//   %client.defenseScore = 0;
//   %client.genDefends = 0;
//   %client.carrierKills = 0;
//   %client.escortAssists = 0;
//   %client.turretKills = 0;
//   %client.mannedTurretKills = 0;
//   %client.flagReturns = 0;
//   %client.genRepairs = 0;
//    %client.SensorRepairs   =0;
//    %client.TurretRepairs   =0;
//    %client.StationRepairs  =0;
//    %client.VStationRepairs =0;
//    %client.solarRepairs    =0;
//    %client.sentryRepairs   =0;
//    %client.depInvRepairs   =0;
//    %client.depTurretRepairs=0;
//   %client.returnPts = 0;
   %client.score = 0;
}

// Added SaNTa 19-03-03
function TAC_RetrievalGame::objectRepaired(%game, %obj, %objName)
{
   %item = %obj.getDataBlock().getName();
   switch$ (%item)
   {
      case generatorLarge :
         %game.genOnRepaired(%obj, %objName);
      case sensorMediumPulse :
         %game.sensorOnRepaired(%obj, %objName);
      case sensorLargePulse :
         %game.sensorOnRepaired(%obj, %objName);
      case stationInventory :
         %game.stationOnRepaired(%obj, %objName);
      case turretBaseLarge :
         %game.turretOnRepaired(%obj, %objName);
      case stationVehicle :
        %game.vStationOnRepaired(%obj, %objName);
      case solarPanel :
        %game.solarPanelOnRepaired(%obj, %objName);
      case sentryTurret :
        %game.sentryTurretOnRepaired(%obj, %objName);
      case TurretDeployedWallIndoor:
        %game.depTurretOnRepaired(%obj, %objName);
      case TurretDeployedFloorIndoor:
        %game.depTurretOnRepaired(%obj, %objName);
      case TurretDeployedCeilingIndoor:
        %game.depTurretOnRepaired(%obj, %objName);
      case TurretDeployedOutdoor:
        %game.depTurretOnRepaired(%obj, %objName);
   }
   %obj.wasDisabled = false;
}
// Added SaNTa 19-03-03
function TAC_RetrievalGame::genOnRepaired(%game, %obj, %objName)
{

   if (%game.testValidRepair(%obj))
   {
      %repairman = %obj.repairedBy;
      teamRepairMessage(%repairman, 'msgGenRepaired', '\c0%1 repaired the %2 Generator!', %repairman.name, %obj.nameTag);
   }
}
// Added SaNTa 19-03-03
function TAC_RetrievalGame::stationOnRepaired(%game, %obj, %objName)
{
   if (%game.testValidRepair(%obj))
   {
      %repairman = %obj.repairedBy;
      teamRepairMessage(%repairman, 'msgStationRepaired', '\c0%1 repaired the %2 Inventory Station!', %repairman.name, %obj.nameTag);
   }
}
// Added SaNTa 19-03-03
function TAC_RetrievalGame::sensorOnRepaired(%game, %obj, %objName)
{
   if (%game.testValidRepair(%obj))
   {
      %repairman = %obj.repairedBy;
      teamRepairMessage(%repairman, 'msgSensorRepaired', '\c0%1 repaired the %2 Pulse Sensor!', %repairman.name, %obj.nameTag);
   }
}
// Added SaNTa 19-03-03
function TAC_RetrievalGame::turretOnRepaired(%game, %obj, %objName)
{
   if (%game.testValidRepair(%obj))
   {
      %repairman = %obj.repairedBy;
      teamRepairMessage(%repairman, 'msgTurretRepaired', '\c0%1 repaired the %2 Turret!', %repairman.name, %obj.nameTag);
   }
}
// Added SaNTa 19-03-03
function TAC_RetrievalGame::vStationOnRepaired(%game, %obj, %objName)
{
   if (%game.testValidRepair(%obj))
   {
      %repairman = %obj.repairedBy;
      teamRepairMessage(%repairman, 'msgvstationRepaired', '\c0%1 repaired the Vehicle Station!', %repairman.name);
   }
}
// Added SaNTa 19-03-03
function TAC_RetrievalGame::solarPanelOnRepaired(%game, %obj, %objName)
{
   if (%game.testValidRepair(%obj))
   {
      %repairman = %obj.repairedBy;
      teamRepairMessage(%repairman, 'msgsolarRepaired', '\c0%1 repaired the %2 Solar Panel!', %repairman.name, %obj.nameTag);
   }
}
// Added SaNTa 19-03-03
function TAC_RetrievalGame::sentryTurretOnRepaired(%game, %obj, %objName)
{
   if (%game.testValidRepair(%obj))
   {
      %repairman = %obj.repairedBy;
      teamRepairMessage(%repairman, 'msgsentryTurretRepaired', '\c0%1 repaired the %2 Sentry Turret!', %repairman.name, %obj.nameTag);
   }
}
// Added SaNTa 19-03-03
function TAC_RetrievalGame::depTurretOnRepaired(%game, %obj, %objName)
{
   if (%game.testValidRepair(%obj))
   {
      %repairman = %obj.repairedBy;
   }
}
// Added SaNTa 19-03-03
function TAC_RetrievalGame::depInvOnRepaired(%game, %obj, %objName)
{
   if (%game.testValidRepair(%obj))
   {
      %repairman = %obj.repairedBy;
   }
}
// Added SaNTa 19-03-03
function TAC_RetrievalGame::testValidRepair(%game, %obj)
{
    if(!%obj.wasDisabled)
    {
        //error(%obj SPC "was never disabled");
        return false;
    }
    else if(%obj.lastDamagedByTeam == %obj.team)
    {
        //error(%obj SPC "was last damaged by a friendly");
        return false;
    }
    else if(%obj.team != %obj.repairedBy.team)
    {
        //error(%obj SPC "was repaired by an enemy");
        return false;
    }
    else
    {
        if(%obj.soiledByEnemyRepair)
            %obj.soiledByEnemyRepair = false;
        return true;
    }
}
// Added SaNTa 19-03-03
function TAC_RetrievalGame::applyConcussion(%game, %player)
{
}

