//	This group of camera controls is dedicated to the amazing
//	Iron Chef Frappe who waited over 18 months for these to be created!



//======================================================================
//	Observer Cam Zoom Lenses

observerMap.bind(keyboard,"ctrl e", setZoomFOV);
observerMap.bind(keyboard, "ctrl z", toggleZoom);


$ObsRemapName[$ObsRemapCount] = "Zoom";
$ObsRemapCmd[$ObsRemapCount] = "toggleZoom";
$ObsRemapCount++;
$ObsRemapName[$ObsRemapCount] = "Cycle Zoom Level";
$ObsRemapCmd[$ObsRemapCount] = "setZoomFOV";
$ObsRemapCount++;



//======================================================================
//	HUD Removal / Display

function toggleHUDDisplay( %val )
{
   	if ( %val )
   	{
      	if(outerChatHud.isVisible())
      	{
      	   	clientcmdTogglePlayHuds(0);
      	   	bottomPrintDlg.setVisible(false);
      	   	//centerPrintDlg.setVisible(false);
		}
      	else
      	{
      		clientcmdTogglePlayHuds(1);
      	   	bottomPrintDlg.setVisible(true);
      	   	//centerPrintDlg.setVisible(true);
		}
  	}
}

observerMap.bind( keyboard, "ctrl a",  toggleHUDDisplay );

$ObsRemapName[$ObsRemapCount] = "Toggle HUDs";
$ObsRemapCmd[$ObsRemapCount] = "toggleHUDDisplay";
$ObsRemapCount++;



//======================================================================
//	Toggle Bullet Cam

function toggleBulletCam( %val )
{
   	if ( %val )
   	{
      	if($TACBulletCamEnabled)
      	{
      	   	$TACBulletCamEnabled = false;
			commandToServer( 'setBulletCam', false );
			error("TAC2 Bullet Cam Disabled");
		}
      	else
      	{
			$TACBulletCamEnabled = true;
			commandToServer( 'setBulletCam', true );
			error("TAC2 Bullet Cam Enabled");
		}
  	}
}

observerMap.bind( keyboard, "ctrl b",  toggleBulletCam );

$ObsRemapName[$ObsRemapCount] = "Toggle Bullet Cam";
$ObsRemapCmd[$ObsRemapCount] = "toggleBulletCam";
$ObsRemapCount++;




//======================================================================
//	Camera orbit distance settings

function useCameraRangeOne( %val )
{
   if ( %val )
   {
      commandToServer( 'setCameraOrbitRange', 1 );
   }
}

function useCameraRangeTwo( %val )
{
   if ( %val )
   {
      commandToServer( 'setCameraOrbitRange', 2 );
   }
}

function useCameraRangeThree( %val )
{
   if ( %val )
   {
      commandToServer( 'setCameraOrbitRange', 3 );
   }

}

function useCameraRangeFour( %val )
{
   if ( %val )
   {
      commandToServer( 'setCameraOrbitRange', 4 );
   }

}

function useCameraRangeFive( %val )
{
   if ( %val )
	{
      commandToServer( 'setCameraOrbitRange', 5 );
   }
}

function useCameraRangeSix( %val )
{
   if ( %val )
   {
      commandToServer( 'setCameraOrbitRange', 6 );
   }
}

function useCameraRangeSeven( %val )
{
   if ( %val )
   {
      commandToServer( 'setCameraOrbitRange', 7 );
   }
}

function useCameraRangeEight( %val )
{
   if ( %val )
   {
      commandToServer( 'setCameraOrbitRange', 8 );
   }
}

function useCameraRangeNine( %val )
{
   if ( %val )
   {
      commandToServer( 'setCameraOrbitRange', 9 );
   }

}

function useCameraRangeTen( %val )
{
   if ( %val )
   {
      commandToServer( 'setCameraOrbitRange', 0 );
   }
}


observerMap.bind( keyboard, "shift 1",  useCameraRangeOne );
observerMap.bind( keyboard, "shift 2",  useCameraRangeTwo );
observerMap.bind( keyboard, "shift 3",  useCameraRangeThree );
observerMap.bind( keyboard, "shift 4",  useCameraRangeFour );
observerMap.bind( keyboard, "shift 5",  useCameraRangeFive );
observerMap.bind( keyboard, "shift 6",  useCameraRangeSix );
observerMap.bind( keyboard, "shift 7",  useCameraRangeSeven );
observerMap.bind( keyboard, "shift 8",  useCameraRangeEight );
observerMap.bind( keyboard, "shift 9",  useCameraRangeNine );
observerMap.bind( keyboard, "shift 0",  useCameraRangeTen );

$ObsRemapName[$ObsRemapCount] = "Orbit Range 1";
$ObsRemapCmd[$ObsRemapCount] = "useCameraRangeOne";
$ObsRemapCount++;
$ObsRemapName[$ObsRemapCount] = "Orbit Range 2";
$ObsRemapCmd[$ObsRemapCount] = "useCameraRangeTwo";
$ObsRemapCount++;
$ObsRemapName[$ObsRemapCount] = "Orbit Range 3";
$ObsRemapCmd[$ObsRemapCount] = "useCameraRangeThree";
$ObsRemapCount++;
$ObsRemapName[$ObsRemapCount] = "Orbit Range 4";
$ObsRemapCmd[$ObsRemapCount] = "useCameraRangeFour";
$ObsRemapCount++;
$ObsRemapName[$ObsRemapCount] = "Orbit Range 5";
$ObsRemapCmd[$ObsRemapCount] = "useCameraRangeFive";
$ObsRemapCount++;
$ObsRemapName[$ObsRemapCount] = "Orbit Range 6";
$ObsRemapCmd[$ObsRemapCount] = "useCameraRangeSix";
$ObsRemapCount++;
$ObsRemapName[$ObsRemapCount] = "Orbit Range 7";
$ObsRemapCmd[$ObsRemapCount] = "useCameraRangeSeven";
$ObsRemapCount++;
$ObsRemapName[$ObsRemapCount] = "Orbit Range 8";
$ObsRemapCmd[$ObsRemapCount] = "useCameraRangeEight";
$ObsRemapCount++;
$ObsRemapName[$ObsRemapCount] = "Orbit Range 9";
$ObsRemapCmd[$ObsRemapCount] = "useCameraRangeNine";
$ObsRemapCount++;
$ObsRemapName[$ObsRemapCount] = "Orbit Range 10";
$ObsRemapCmd[$ObsRemapCount] = "useCameraRangeTen";
$ObsRemapCount++;






