//=====================================================================================
//	TAC2 - Things that make you go boom						Wizard_TPG - 11/5/2001
//
//	Includes:
//			New Ground Kill Messages
//			Ground Testing Code
//			Ground Kill
//			Shield vs Ground Test
//			Disc off platform checking
//
//=====================================================================================

//================================================
// CODE
//================================================

function Player::StandingOnTerrainCheck (%player)
{
	if(%player.getState() $= "Dead")
		return false;

	//if player is in vehicle return false
	if(%player.isMounted())
		return false;
  

	%position = %player.getPosition();
	%x = getword(%position, 0);
	%y = getword(%position, 1);
	%z = getword(%position, 2);
	for(%xdif = -2; %xdif <= 2; %xdif=%xdif+1)
	{
		for(%ydif = -2; %ydif <= 2; %ydif=%ydif+1)
		{
			%start = (%x+%xdif) SPC (%y+%ydif) SPC 2000;
			%end = %x @ " " @ %y @ " -1";
			%ground = containerRayCast(%start, %end, $TypeMasks::TerrainObjectType, 0);
			%groundz = getWord(%ground, 3);
			%diffz = %z - %groundz;
			if(%diffz <= 1.30 && %diffz >= -0.40)
				return true;
		}
	}
	return false;
}


function Player::KillPlayerGround(%this)
{
   	%damageType = $DamageType::Ground;
   	%attackcl = 0;
   	if((getSimTime() - %this.lastDamaged) <= 7000)
   	{
		if(%this.lastDamagedType $= $DamageType::Disc ||	%this.lastDamagedType $= $DamageType::Grenade ||
			%this.lastDamagedType $= $DamageType::ELF ||	%this.lastDamagedType $= $DamageType::Mortar ||
			%this.lastDamagedType $= $DamageType::Missile ||	%this.lastDamagedType $= $DamageType::ShockLance ||
			%this.lastDamagedType $= $DamageType::Mine ||	%this.lastDamagedType $= $DamageType::Explosion ||
			%this.lastDamagedType $= $DamageType::Impact || %this.lastDamagedType $= $DamageType::BellyTurret ||
			%this.lastDamagedType $= $DamageType::BomberBombs || %this.lastDamagedType $= $DamageType::TankChaingun ||
			%this.lastDamagedType $= $DamageType::TankMortar || %this.lastDamagedType $= $DamageType::SatchelCharge)
		{
			%attackcl = %this.lastDamagedByWho;
	   		%damageType = %this.lastDamagedType;
	   		%this.lastDamagedByWho = 0;
	   		%this.lastDamagedType = 0;
	   		%this.lastDamaged = 0;
		}
   	}

	//kill player
   	%this.setInvincible(false);
   	%this.getdatablock().damageObject(%this, %attackcl.player, %this.getPosition(), 10000, %damageType);
   	%this.terrainlooptest = false;
   	cancel(%this.terrainloop);
   	%this.groundkilled = true;

}


function Player::GroundKill(%this, %looptest)
{
	if(!%looptest && %this.terrainlooptest)
		return;

	if(%this.isShielded)
	{
		//player has shield pack on....run another check in 250ms
		cancel(%this.terrainloop);
		if(!%this.terrainlooptest)
			%this.terrainlooptest = true;
		%velocity = %this.getVelocity();
		%velx = getword(%velocity,0);
		%vely = getword(%velocity,1);
        %velz = getword(%velocity,2);  // SaNTa 07-11-02
		if(%velx > 16 || %vely > 16 || %velz > 90 || %velx < -16 || %vely < -16 || %velz < -90)  // Mod'd by SaNTa 07-11-02
			%this.setEnergyLevel(0);
		%energy = %this.getEnergyLevel();
		%reduction = %this.getdatablock().maxEnergy / 120;
		%newenergy = (%energy - %reduction) > 0 ? (%energy - %reduction) : 0;
		%this.setEnergyLevel(%newenergy);
		if(%newenergy >= 3)
		{
			//damage flash and special loop
			%this.groundflash += 0.075;
			if(%this.groundflash > 0.75)
				%this.groundflash = 0.75;
			%this.setDamageFlash(%this.groundflash);
			%this.terrainloop = %this.schedule(250,"TerrainTestLoop");
		}
		else
		{
			//no energy for shield.....boom
			%this.KillPlayerGround();
		}
	}
	else
	{
		//player go boom
		%this.KillPlayerGround();
	}
}

function Player::TerrainTestLoop (%this)
{
	if(!isObject(%this))
		return;

	if(%this.groundkilled $= "")
		%this.groundkilled = false;

	if(%this.StandingOnTerrainCheck())
	{
		//Player is standing on ground...kill the bastard!
		%this.GroundKill(true);
	}
	else
	{
		%this.groundflash = 0;
		cancel(%this.terrainloop);
		%this.terrainlooptest = false;
	}
}

